%function to compute the variance of moments to use in the computation of
%variance of the estimated parameters

function f=varmomentones_clus_onecons(x)

global alphaf3list alphaf4list alphaf5list alpham3list alpham4list alpham5list alphak3list alphak4list alphak5list betaf3list betam3list betak3list betaf4list betam4list betak4list betaf5list betam5list betak5list eta_z3list eta_z4list eta_z5list x3 x4 x5 tiny eta_k3list eta_k4list eta_k5list nkids3 nkids4 nkids5 sf_3 sf_4 sf_5 sm_3 sm_4 sm_5 sk_3 sk_4 sk_5 x3hat x4hat x5hat instlist3 instlist4 instlist5 xnlsuri2 village3;

s_predicted=fittedonestep_onecons(xnlsuri2);
sf3hat=s_predicted(:,1);
sm3hat=s_predicted(:,2);
sk3hat=s_predicted(:,3);
sf4hat=s_predicted(:,4);
sm4hat=s_predicted(:,5);
sk4hat=s_predicted(:,6);
sf5hat=s_predicted(:,7);
sm5hat=s_predicted(:,8);
sk5hat=s_predicted(:,9);

eta3fhat=s_predicted(:,10);
eta3mhat=s_predicted(:,11);
eta4fhat=s_predicted(:,12);
eta4mhat=s_predicted(:,13);
eta5fhat=s_predicted(:,14);
eta5mhat=s_predicted(:,15);

bf3hat=s_predicted(:,16);
bm3hat=s_predicted(:,17);
bk3hat=s_predicted(:,18);
bf4hat=s_predicted(:,19);
bm4hat=s_predicted(:,20);
bk4hat=s_predicted(:,21);
bf5hat=s_predicted(:,22);
bm5hat=s_predicted(:,23);
bk5hat=s_predicted(:,24);


inst_eq1_eta3f=(sf3hat./eta3fhat)+bf3hat;
inst_eq2_eta3m=(sm3hat./eta3mhat)+bm3hat;
inst_eq3_eta3=-(sk3hat./(ones(size(x3,1),1)-eta3fhat-eta3mhat))-bk3hat;
inst_eq4_eta4f=(sf4hat./eta4fhat)+bf4hat;
inst_eq5_eta4m=(sm4hat./eta4mhat)+bm4hat;
inst_eq6_eta4=-(sk4hat./(ones(size(x3,1),1)-eta4fhat-eta4mhat))-bk4hat;
inst_eq7_eta5f=(sf5hat./eta5fhat)+bf5hat;
inst_eq8_eta5m=(sm5hat./eta5mhat)+bm5hat;
inst_eq9_eta5=-(sk5hat./(ones(size(x3,1),1)-eta5fhat-eta5mhat))-bk5hat;
inst_eq1_alphaf3=eta3fhat;
inst_eq2_alpham3=eta3mhat;
inst_eq3_alphak3=ones(size(x3,1),1)-eta3fhat-eta3mhat;
inst_eq4_alphaf4=eta4fhat;
inst_eq5_alpham4=eta4mhat;
inst_eq6_alphak4=ones(size(x3,1),1)-eta4fhat-eta4mhat;
inst_eq7_alphaf5=eta5fhat;
inst_eq8_alpham5=eta5mhat;
inst_eq9_alphak5=ones(size(x3,1),1)-eta5fhat-eta5mhat;
inst_eq1_betaf=eta3fhat.*(x3hat+log(eta3fhat));
inst_eq2_betam=eta3mhat.*(x3hat+log(eta3mhat));
inst_eq3_betak=(ones(size(x3,1),1)-eta3fhat-eta3mhat).*(x3hat-log(nkids3)+log(ones(size(x3,1),1)-eta3fhat-eta3mhat));
inst_eq4_betaf=eta4fhat.*(x4hat+log(eta4fhat));
inst_eq5_betam=eta4mhat.*(x4hat+log(eta4mhat));
inst_eq6_betak=(ones(size(x3,1),1)-eta4fhat-eta4mhat).*(x4hat-log(nkids4)+log(ones(size(x3,1),1)-eta4fhat-eta4mhat));
inst_eq7_betaf=eta5fhat.*(x5hat+log(eta5fhat));
inst_eq8_betam=eta5mhat.*(x5hat+log(eta5mhat));
inst_eq9_betak=(ones(size(x3,1),1)-eta5fhat-eta5mhat).*(x5hat-log(nkids5)+log(1-eta5fhat-eta5mhat));

for i=1:15;
instruments_eq1(:,i)=inst_eq1_eta3f.*instlist3(:,i);
instruments_eq1(:,i+15)=inst_eq1_alphaf3.*instlist3(:,i);
instruments_eq1(:,i+30)=inst_eq1_betaf.*instlist3(:,i);
instruments_eq2(:,i)=inst_eq2_eta3m.*instlist3(:,i);
instruments_eq2(:,i+15)=inst_eq2_alpham3.*instlist3(:,i);
instruments_eq2(:,i+30)=inst_eq2_betam.*instlist3(:,i);
instruments_eq3(:,i)=inst_eq3_eta3.*instlist3(:,i);
instruments_eq3(:,i+15)=inst_eq3_alphak3.*instlist3(:,i);
instruments_eq3(:,i+30)=inst_eq3_betak.*instlist3(:,i);
instruments_eq4(:,i)=inst_eq4_eta4f.*instlist4(:,i);
instruments_eq4(:,i+15)=inst_eq4_alphaf4.*instlist4(:,i);
instruments_eq4(:,i+30)=inst_eq4_betaf.*instlist4(:,i);
instruments_eq5(:,i)=inst_eq5_eta4m.*instlist4(:,i);
instruments_eq5(:,i+15)=inst_eq5_alpham4.*instlist4(:,i);
instruments_eq5(:,i+30)=inst_eq5_betam.*instlist4(:,i);
instruments_eq6(:,i)=inst_eq6_eta4.*instlist4(:,i);
instruments_eq6(:,i+15)=inst_eq6_alphak4.*instlist4(:,i);
instruments_eq6(:,i+30)=inst_eq6_betak.*instlist4(:,i);
instruments_eq7(:,i)=inst_eq7_eta5f.*instlist5(:,i);
instruments_eq7(:,i+15)=inst_eq7_alphaf5.*instlist5(:,i);
instruments_eq7(:,i+30)=inst_eq7_betaf.*instlist5(:,i);
instruments_eq8(:,i)=inst_eq8_eta5m.*instlist5(:,i);
instruments_eq8(:,i+15)=inst_eq8_alpham5.*instlist5(:,i);
instruments_eq8(:,i+30)=inst_eq8_betam.*instlist5(:,i);
instruments_eq9(:,i)=inst_eq9_eta5.*instlist5(:,i);
instruments_eq9(:,i+15)=inst_eq9_alphak5.*instlist5(:,i);
instruments_eq9(:,i+30)=inst_eq9_betak.*instlist5(:,i);
end;

E3f=[x(1) x(2) x(3) x(4) x(5) x(6) x(7) x(8) x(9) x(10) x(11) x(12) x(13) x(14) x(15) x(16) x(17)];
E3m=[x(18) x(19) x(20) x(21) x(22) x(23) x(24) x(25) x(26) x(27) x(28) x(29) x(30) x(31) x(32) x(33) x(34)];
E4f=[x(35) x(36) x(37) x(38) x(39) x(40) x(41) x(42) x(43) x(44) x(45) x(46) x(47) x(48) x(49) x(50) x(51)];
E4m=[x(52) x(53) x(54) x(55) x(56) x(57) x(58) x(59) x(60) x(61) x(62) x(63) x(64) x(65) x(66) x(67) x(68)];
E5f=[x(69) x(70) x(71) x(72) x(73) x(74) x(75) x(76) x(77) x(78) x(79) x(80) x(81) x(82) x(83) x(84) x(85)];
E5m=[x(86) x(87) x(88) x(89) x(90) x(91) x(92) x(93) x(94) x(95) x(96) x(97) x(98) x(99) x(100) x(101) x(102)];
A3f=[x(103) x(104) x(105) x(106) x(107) x(108) x(109) x(110) x(111) x(112) x(113) x(114) x(115) x(116) x(117) x(118) x(119)];
A3m=[x(120) x(121) x(122) x(123) x(124) x(125) x(126) x(127) x(128) x(129) x(130) x(131) x(132) x(133) x(134) x(135) x(136)];
A3k=[x(137) x(138) x(139) x(140) x(141) x(142) x(143) x(144) x(145) x(146) x(147) x(148) x(149) x(150) x(151) x(152) x(153)];
A4f=[x(154) x(155) x(156) x(157) x(158) x(159) x(160) x(161) x(162) x(163) x(164) x(165) x(166) x(167) x(168) x(169) x(170)];
A4m=[x(171) x(172) x(173) x(174) x(175) x(176) x(177) x(178) x(179) x(180) x(181) x(182) x(183) x(184) x(185) x(186) x(187)];
A4k=[x(188) x(189) x(190) x(191) x(192) x(193) x(194) x(195) x(196) x(197) x(198) x(199) x(200) x(201) x(202) x(203) x(204)];
A5f=[x(205) x(206) x(207) x(208) x(209) x(210) x(211) x(212) x(213) x(214) x(215) x(216) x(217) x(218) x(219) x(220) x(221)];
A5m=[x(222) x(223) x(224) x(225) x(226) x(227) x(228) x(229) x(230) x(231) x(232) x(233) x(234) x(235) x(236) x(237) x(238)];
A5k=[x(239) x(240) x(241) x(242) x(243) x(244) x(245) x(246) x(247) x(248) x(249) x(250) x(251) x(252) x(253) x(254) x(255)];
Bf=[x(256) x(257) x(258) x(259) x(260) x(261) x(262) x(263) x(264) x(265) x(266) x(267) x(268) x(269) x(270) x(271) x(272)];
Bm=[x(273) x(274) x(275) x(276) x(277) x(278) x(279) x(280) x(281) x(282) x(283) x(284) x(285) x(286) x(287) x(288) x(289)];
Bk=[x(290) x(291) x(292) x(293) x(294) x(295) x(296) x(297) x(298) x(299) x(300) x(301) x(302) x(303) x(304) x(305) x(306)];

eta3f_nlsur=[eta_k3list eta_z3list];
eta3m_nlsur=[eta_k3list eta_z3list];
eta4f_nlsur=[eta_k4list eta_z4list];
eta4m_nlsur=[eta_k4list eta_z4list];
eta5f_nlsur=[eta_k5list eta_z5list];
eta5m_nlsur=[eta_k5list eta_z5list];

em3=E3m*eta3m_nlsur';
ef3=E3f*eta3f_nlsur';
ef4=E4f*eta4f_nlsur';
em4=E4m*eta4m_nlsur';
ef5=E5f*eta5f_nlsur';
em5=E5m*eta5m_nlsur';

af3=A3f*alphaf3list';
af4=A4f*alphaf4list';
af5=A5f*alphaf5list';
am3=A3m*alpham3list';
am4=A4m*alpham4list';
am5=A5m*alpham5list';
ak3=A3k*alphak3list';
ak4=A4k*alphak4list';
ak5=A5k*alphak5list';


bf3=Bf*betaf3list';
bm3=Bm*betam3list';
bk3=Bk*betak3list';
bf4=Bf*betaf4list';
bm4=Bm*betam4list';
bk4=Bk*betak4list';
bf5=Bf*betaf5list';
bm5=Bm*betam5list';
bk5=Bk*betak5list';

sf3=sf_3-(ef3'.*(af3'+bf3'.*(x3+log(ef3'))));
sm3=sm_3-(em3'.*(am3'+bm3'.*(x3+log(em3'))));
sk3=sk_3-((ones(size(x3,1),1)-ef3'-em3').*(ak3'+bk3'.*(x3+log(ones(size(x3,1),1)-ef3'-em3')-log(nkids3))));
sf4=sf_4-(ef4'.*(af4'+bf4'.*(x4+log(ef4'))));
sm4=sm_4-(em4'.*(am4'+bm4'.*(x4+log(em4'))));
sk4=sk_4-((ones(size(x3,1),1)-ef4'-em4').*(ak4'+bk4'.*(x4+log(ones(size(x3,1),1)-ef4'-em4')-log(nkids4))));
sf5=sf_5-(ef5'.*(af5'+bf5'.*(x5+log(ef5'))));
sm5=sm_5-(em5'.*(am5'+bm5'.*(x5+log(em5'))));
sk5=sk_5-((ones(size(x3,1),1)-ef5'-em5').*(ak5'+bk5'.*(x5+log(ones(size(x3,1),1)-ef5'-em5')-log(nkids5))));

m1=zeros(size(x3,1),45);
m2=zeros(size(x3,1),45);
m3=zeros(size(x3,1),45);
m4=zeros(size(x3,1),45);
m5=zeros(size(x3,1),45);
m6=zeros(size(x3,1),45);
m7=zeros(size(x3,1),45);
m8=zeros(size(x3,1),45);
m9=zeros(size(x3,1),45);

for i=1:45;
    m1(:,i)=sf3.*instruments_eq1(:,i);
    m2(:,i)=sm3.*instruments_eq2(:,i);
    m3(:,i)=sk3.*instruments_eq3(:,i);
    m4(:,i)=sf4.*instruments_eq4(:,i);
    m5(:,i)=sm4.*instruments_eq5(:,i);
    m6(:,i)=sk4.*instruments_eq6(:,i);
    m7(:,i)=sf5.*instruments_eq7(:,i);
    m8(:,i)=sm5.*instruments_eq8(:,i);
    m9(:,i)=sk5.*instruments_eq9(:,i);
end;

moments=[m1 m2 m3 m4 m5 m6 m7 m8 m9];

M=zeros(405,405,452);
for i=1:452;
    M1=moments(find(village3==i),:);
    M(:,:,i)=M1'*M1;
end
f=(1/452)*sum(M,3);

